Minimum Path Sum 基本动态规划:二维--力扣101算法题解笔记

7.3Minimum Path Sum 基本动态规划:二维

题目描述

给定一个m*n大小的非负整数矩阵,求从左上角开始到右下角结束的、经过的数字的和最小的路径。每次只能向右或向下移动

输入输出样例

Input :

\[1, 3, 1,

1, 5, 1,

4, 2, 1\]

Output:7

也就是说1-3-1-1-1,一共是7

题解

这个也是要利用题目的逻辑转换成数组、进而转换成状态方程,然后用算法求解

先定义一个同样是二维的dp数组,dpij表示左上角开始到第(i, j)位置的最优路径的数字和。因为每次只能向下或向右移动,我们可以得到状态转移方程为dpij = min(doi-1j, dpij-1 + gridij)。grid为原数组

转换为算法的代码如下:

cpp 复制代码
#include <iostream>
#include <vector>
using namespace std;

int minPathSum(vector<vector<int>>& grid) {
    int m = grid.size(), n = grid[0].size();
    vector<vector<int>> dp(m, vector<int>(n, 0));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == 0 && j == 0) {
                dp[i][j] = grid[i][j];
            }
            else if (i == 0) {
                dp[i][j] = dp[i][j - 1] + grid[i][j];
            }
            else if (j == 0) {
                dp[i][j] = dp[i - 1][j] + grid[i][j];
            }
            else {
                dp[i][j] = min(dp[i - 1][j], dp[i][j - 1]) + grid[i][j];
            }
        }
    }
    return dp[m - 1][n - 1];
}

int main() {
    vector<vector<int>> grid = { {1,3,1},{1,5,1},{4,2,1} };
    cout << minPathSum(grid) << endl;
    return 0;
}
相关推荐
罗湖老棍子8 小时前
Biorhythms(信息学奥赛一本通- P1639)
算法·数论·裴蜀定理·扩展欧几里得·扩展中国剩余定理
奋发向前wcx13 小时前
CSP-J复赛模拟赛4 王晨旭补题 2026.10.5
算法
念何架构之路16 小时前
zap采样器与性能优化内幕
算法·性能优化·哈希算法
晒太羊的猫17 小时前
hot100动态规划刷题
算法·动态规划
weixin_5310946917 小时前
heap_4内存管理
java·开发语言·算法
余额瞒着我当琳17 小时前
红黑树的实现--红黑树的概念、规则、效率、结构、旋转、查找、验证
数据结构·c++·算法
程序员南飞17 小时前
win系统安装minio
java·数据结构·算法
青少儿编程课堂17 小时前
AC自动机多模式串匹配精讲:校园关键词巡检实战解析
c++·python·算法·bfs·信息学竞赛
longlongzihan18 小时前
LeetCode 5. 最长回文子串:从暴力匹配到中心扩展的思维演进
c++·算法·leetcode
waoooqwe18 小时前
问卷样本真实吗
大数据·数据库·算法·数据分析